<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.48 $
 * $Author: joergk $
 * $Date: 2010/02/14 17:53:26 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

$wysiwyg = 0;
$wysiwyg_anews = 0;
$wysiwyg_snews = 0;
include_once('spaw/spaw_control.class.php');

/**
 * nur noch dummy, fuer aeltere Themes
 */
function convertNewsForView($msg)
{
    return $msg;
}

/**
 */
function vkpGetStoryDetails($story)
{
    global $prefix;
    if (!isset($story['sid'])) {
        $story['sid'] = 0;
    }
    if (!isset($story['aid'])) {
        $story['aid'] = '';
    }
    if (!isset($story['acomm'])) {
        $story['acomm'] = 0;
    }
    if (!isset($story['time'])) {
        $story['time'] = sprintf("%04d-%02d-%02d", date('Y'), date('m'), date('d'));
    }
    if (empty($story['counter']) || intval($story['counter']) < 0) {
        $story['counter'] = 0;
    }
    if (empty($story['comments']) || intval($story['comments']) < 0) {
        $story['comments'] = 0;
    }
    if (!isset($story['cattitle']) && !empty($story['catid'])) {
        $result = sql_query("SELECT title as cattitle FROM {$prefix}_stories_cat WHERE catid=" . intval($story['catid']) . "");
        $cat = sql_fetch_assoc($result);
        $story['cattitle'] = (empty($cat['cattitle'])) ? '' : $cat['cattitle'];
    }
    if (!isset($story['cattitle'])) {
        $story['cattitle'] = '';
        $story['catid'] = 0;
    }
    if (!isset($story['topicimage']) && !empty($story['topic'])) {
        $result = sql_query("SELECT topicimage, topictext FROM {$prefix}_topics WHERE topicid=" . intval($story['topic']) . "");
        $topic = sql_fetch_assoc($result);
        $story['topicimage'] = (empty($topic['topicimage'])) ? '' : $topic['topicimage'];
        $story['topictext'] = (empty($topic['topictext'])) ? '' : $topic['topictext'];
    }
    if (!isset($story['topicimage'])) {
        $story['topicimage'] = '';
        $story['topic'] = 0;
    }
    if (!isset($story['topictext'])) {
        $story['topictext'] = '';
    }
    if (!isset($story['datetime'])) {
        $story['datetime'] = formatTimestamp($story['time']);
    }

    $tmp = array('hometext', 'bodytext', 'notes');
    foreach ($tmp as $key) {
        // Texte bereinigen, die evtl. nur leere Tags enthalten
        if (!strip_tags($story[$key], '<img><embed><object>')) {
            $story[$key] = '';
        }
    }

    if (!isset($story['allmorelink'])) {
        $story['allmorelink'] = vkpGetMoreLink($story);
    }
    $story['morelink'] = $story['allmorelink']['formated'];
    if (empty($story['title'])) {
        $story['title'] = $story['topictext'];
    }
    $story['title_formated'] = $story['title'];
    if (!empty($story['catid'])) {
        $story['title_formated'] = "<a href=\"modules.php?name=News&amp;file=categories&amp;catid=" . $story['catid'] . "\"><span class=\"smaller storycat\">" . $story['cattitle'] . "</span></a>: " . $story['title'];
    }
    return $story;
}

/**
 */
function vkpShowPageLinks($numpages, $pagenum, $storynum, $allstories, $linkadd, $title = "")
{
    if ($numpages > 1) {
        static $out;
        if (empty($out)) {
            $start = 1;
            $end = $numpages + 1;
            if ($numpages > 10) {
                $start = $pagenum - 4;
                if ($start < 1) $start = 1;
                $end = $start + 10;
                if ($end > $numpages) $end = $numpages + 1;
                if ($end == $numpages + 1) $start = $end - 10;
            }
            $pagenum = (empty($pagenum)) ? 1 : (int)$pagenum;
            $backlink = ($pagenum > 1) ? " href=\"modules.php?name=News&amp;pagenum=" . ($pagenum - 1) . $linkadd . "\"" : "";
            $nextlink = ($pagenum < $numpages) ? " href=\"modules.php?name=News&amp;pagenum=" . ($pagenum + 1) . $linkadd . "\"" : "";

            $out = '<h4 class="align-center">' . $allstories . ' ' . _NEWS_ARTICLE . " (" . $numpages . ' ' . _NEWS_PAGES . ", " . $storynum . ' ' . _NEWS_ARTICLEPERPAGE . ")</h4>";
            $out .= '<div class="pagination align-center">';

            if ($pagenum <= 1) {
                $caption = '';
                $out .= '&laquo;' . "\n";
            } else {
                $caption = _NEWS_TOPAGE . ": " . ($pagenum - 1) ;
                $out .= '<a' . $backlink . ' title="' . $caption . '">&laquo;</a>' . "\n";
            }

            if ($start > 1) {
                $out .= " <a href=\"modules.php?name=News" . $linkadd . "\" title=\"" . _NEWS_TOPAGEFIRST . "\">1</a>\n";
                if ($start > 2) $out .= " .. ";
            }
            for ($i = $start; $i < $end; $i++) {
                $out .= ($i == $pagenum) ? ' <b><span class="current">' . $i . "</span></b>\n" : " <a href=\"modules.php?name=News&amp;pagenum=" . $i . $linkadd . "\">" . $i . "</a>\n";
            }
            if ($end < $numpages + 1) {
                if ($end < $numpages) $out .= " .. ";
                $out .= " <a href=\"modules.php?name=News&amp;pagenum=" . $numpages . $linkadd . "\" title=\"" . _NEWS_TOPAGELAST . "\">" . $numpages . "</a>\n";
            }

            if ($pagenum >= $numpages) {
                $caption = '';
                $out .= '&raquo;' . "\n";
            } else {
                $caption = _NEWS_TOPAGE . ": " . ($pagenum + 1) ;
                $out .= '<a' . $nextlink . ' title="' . $caption . '">&raquo;</a>' . "\n";
            }
            $out .= "</div>";
        }
        OpenTable();
        if ($title) {
            echo "<h2 class=\"title\">$title</h2><br />";
        }
        echo $out;
        CloseTable();
        echo '<br />';
    }
}

/**
 */
function vkpGetMoreLink($story)
{
    $formated['homecount'] = strlen(trim(strip_tags($story['hometext'])));

    $check = trim(strip_tags($story['bodytext']));
    if (!$check && trim($story['bodytext'])) {
        $formated['bodycount'] = strlen($story['bodytext']);
    } else {
        $formated['bodycount'] = strlen($check);
    }

    $formated['totalcount'] = $formated['homecount'] + $formated['bodycount'];
    $formated['storylink'] = "<a href=\"modules.php?name=News&amp;file=article&amp;sid=" . $story['sid'] . "\">";
    $formated['printerlink'] = "<a href=\"modules.php?name=News&amp;file=print&amp;sid=" . $story['sid'] . "\" title='" . _PRINTER . "' rel=\"nofollow\" target=\"_blank\">";
    $formated['friendlink'] = (mxModuleAllowed('Recommend_Us')) ? "<a href=\"modules.php?name=News&amp;file=friend&amp;sid=" . $story['sid'] . "\" title='" . _FRIEND . "' rel=\"nofollow\">" : "<a>";
    $formated['datetime'] = _ON . ' <span>' . $story['datetime'] . '</span>';
    $formated['counter'] = $story['counter'] . ' ' . _READS;
    $formated['informantlink'] = (empty($story['informant'])) ? '<a title="' . _BY . ': ' . $GLOBALS['anonymous'] . '">' : mxCreateUserprofileLink($story['informant'], '', _BY . ': ' . $story['informant'], true);
    $formated['comments'] = "0 " . _COMMENTSQ;
    if (!empty($story['url'])) {
        $formated['postedby'] = _POSTEDBY . ' <a href="' . $story['url'] . '" target="_blank">' . $story['aid'] . '</a>';
    } else if (!empty($story['email'])) {
        $formated['postedby'] = _POSTEDBY . ' <a href="mailto:' . mxPrepareToDisplay($story['email']) . '">' . $story['aid'] . '</a>';
    } else {
        $formated['postedby'] = _POSTEDBY . ' ' . $story['aid'];
    }

    if (($formated['bodycount'] > 0) || ($story['comments'] > 0)) {
        $morelink['more'] = $formated['storylink'] . "<b>" . _READMORE . "</b></a>";
    }
    if ($formated['bodycount'] > 0) {
        $morelink['bytemore'] = $formated['totalcount'] . ' ' . _BYTESMORE;
    }
    $morelink['comments'] = "";
    // Kommentare erlaubt?
    if ($GLOBALS['articlecomm'] == 1 && $story['acomm'] == 0) { // Achtung!!! acomm: 0 = Ja , 1 = Nein
        $story['comments'] = (empty($story['comments'])) ? 0 : (int)$story['comments'];
        if (empty($story['comments'])) $formated['comments'] = $story['comments'] . ' ' . _COMMENTSQ;
        else if ($story['comments'] == 1) $formated['comments'] = $story['comments'] . ' ' . _COMMENT;
        else $formated['comments'] = $story['comments'] . ' ' . _COMMENTS;
        $morelink['comments'] = $formated['storylink'] . $formated['comments'] . "</a>";
    }
    // Achtung!!! acomm: 0 = Ja , 1 = Nein
    $formated['commentslink'] = (!empty($story['acomm']) || empty($GLOBALS['articlecomm'])) ? "<a>" : "<a href=\"modules.php?name=News&amp;file=article&amp;sid=" . $story['sid'] . "#comments\" title=\"" . $formated['comments'] . "\">";
    if (empty($formated['bodycount']) && $story['acomm'] == 0) {
        $morelink['comments'] .= " " . $formated['storylink'] . "<b>" . _READMORE . "</b></a>";
    }

    $morelink['functions'] = $formated['printerlink'] . mxCreateImage('images/print.gif', _PRINTER, array('title' => _PRINTER)) . "</a>";
    $morelink['functions'] .= (mxModuleAllowed('Recommend_Us')) ? "&nbsp;&nbsp;" . $formated['friendlink'] . mxCreateImage('images/friend.gif', _FRIEND, array('title' => _FRIEND)) . "</a>" : "";
    if (!empty($story['catid'])) {
        $morelink['categorie'] = "<a href=\"modules.php?name=News&amp;file=categories&amp;catid=" . $story['catid'] . "\" title=\"" . _NEWSCATEGORY . ": " . $story['cattitle'] . "\">" . $story['cattitle'] . "</a>";
    }
    $rated = (empty($story['score'])) ? 0 : substr($story['score'] / $story['ratings'], 0, 4);
    $morelink['score'] = _SCORE . ' ' . $rated;

    $morelink['formated'] = "(" . implode(" | ", $morelink) . ")";

    $morelink = array_merge($morelink, $formated);

    return $morelink;
}

/**
 */
function vkpStoryPreview($story)
{
    // die Daten muessen ohne Backslashes kommen
    if (empty($story['topic'])) {
        $story['topic'] = vkpGetFirstTopic();
    }
    if (function_exists('mx_theme_engineversion')) {
        @mxGetLangfile('News');
        if (MX_IS_USER) {
            $userdata = mxGetUserData();
            $story['informant'] = $userdata['uname'];
        } else {
            $story['informant'] = _YOURNAME;
        }
        $story = vkpGetStoryDetails($story);
        @themearticle(null, null, null, null, null, null, null, null, null, $story);
    } else {
        /* fuer veraltete Themes (nuke etc.) */
        OpenTable();
        echo vkpTopicImage($story['topic'], 1);
        echo "<b>" . mxPrepareToDisplay($story['title']) . "</b><br /><br />";
        echo mxPrepareToDisplay($story['hometext']);
        if (isset($story['bodytext']) && trim(strip_tags($story['bodytext']))) {
            echo '<hr noshade="noshade" size="1" />' . mxPrepareToDisplay($story['bodytext']);
        }
        if (isset($story['notes']) && trim(strip_tags($story['notes']))) {
            echo '<br /><br /><b>' . _NOTE . "</b> <i>" . mxPrepareToDisplay($story['notes']) . "</i>";
        }
        CloseTable();
    }
    echo '<br />';
}

/**
 */
function addNewsTextFields($story)
{
    // die Daten muessen ohne Backslashes kommen
    $show_editor = (MX_IS_ADMIN && $GLOBALS['wysiwyg_anews'] && $GLOBALS['wysiwyg']) || ((!MX_IS_ADMIN) && $GLOBALS['wysiwyg_snews'] && $GLOBALS['wysiwyg']);

    $allowedhtml = '';
    if (!MX_IS_ADMIN && !$show_editor) {
        $allowedhtml = '<br />
		<table cellspacing="0" cellpadding="0"><tr valign="top">
		<td><span class="content" style="white-space: nowrap;">' . _ALLOWEDHTML . '&nbsp;</span></td>
		<td><span class="tiny">&lt;' . implode('&gt; &lt;', mxGetAllowedHtml()) . '&gt;</span></td>
		</tr>
		</table>
		';
    }

    echo "<div>";
    echo "<span class=\"content\"><b>" . _TITLE . "</b></span><br />";
    echo "<input type=\"text\" name=\"title\" size=\"80\" maxlength=\"80\" value=\"" . mxEntityQuotes($story['title']) . "\" />";
    echo "<br /><br /></div>";
    echo '<div><b>' . _STORYTEXT . ':</b><br />';
    if ($show_editor) {
        $sw = new SPAW_Wysiwyg('hometext', $story['hometext'], _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '350');
        $sw->show(); // test
    } else {
        echo "<textarea cols=\"60\" rows=\"17\" name=\"hometext\">" . htmlspecialchars($story['hometext']) . "</textarea>";
        echo $allowedhtml;
    }
    echo "<br /></div>";
    echo "<div><b>" . _EXTENDEDTEXT . ':</b><br />';
    if ($show_editor) {
        $sw = new SPAW_Wysiwyg('bodytext', $story['bodytext'], _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '400');
        $sw->show();
    } else {
        echo "<textarea cols=\"60\" rows=\"17\" name=\"bodytext\">" . htmlspecialchars($story['bodytext']) . "</textarea>";
        echo $allowedhtml;
    }
    echo "<br /></div>";
    // Achtung: Notes funktionieren nur, wenn die Funktion ber das Adminmodul aufgerufen wird
    if (MX_IS_ADMIN && defined("mxAdminFileLoaded")) {
        echo "<div><b>" . _NOTES . ':</b><br />';
        if ($show_editor) {
            $sw = new SPAW_Wysiwyg('notes', $story['notes'], _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '120');
            $sw->show();
        } else {
            echo "<textarea cols=\"60\" rows=\"6\" name=\"notes\">" . htmlspecialchars($story['notes']) . "</textarea>";
        }
        echo "<br /></div>";
    }
}

/**
 */
function vkpNewsSelectLanguage($alanguage = '')
{
    if ($GLOBALS['multilingual']) {
        echo "<br /><b>" . _LANGUAGE . ": </b><br />";
        echo mxLanguageSelect('alanguage', $alanguage, 'language', 1) . '<br />';
    } else {
        echo "<input type=\"hidden\" name=\"alanguage\" value=\"\" />";
    }
}

/**
 */
function vkpSelectTopic($topic = 0)
{
    global $prefix;
    echo "<b>" . _TOPIC . ":</b><br /><select name=\"topic\">";
    $toplist = sql_query("select topicid, topictext from " . $prefix . "_topics order by topictext");
    while (list($topicid, $topictext) = sql_fetch_row($toplist)) {
        $sel = ($topicid == $topic) ? 'selected="selected" class="current"' : '';
        echo "<option $sel value=\"$topicid\">" . mxEntityQuotes($topictext) . "</option>\n";
    }
    echo "</select>";
}

/**
 */
function vkpGetTopics($sid)
{
    global $prefix;
    if (empty($sid)) return array();
    $qry = "SELECT topicid, topicname, topicimage, topictext
                    FROM ${prefix}_stories
                    LEFT JOIN ${prefix}_topics
                    ON ${prefix}_stories.topic = ${prefix}_topics.topicid
                    WHERE ${prefix}_stories.sid = $sid";
    $result = sql_query($qry);
    $row = sql_fetch_array($result);
    return $row;
}

/**
 */
function vkpNewsSelectFormattype($autobreak = 0)
{
    return;
    echo "<input type='checkbox' name='autobreak' value='1' " . ((!empty($autobreak)) ? ' checked="checked"' : '') . " />&nbsp;<b>" . _NEWSAUTOBREAK . "</b>";

    return;
    echo "<b>" . _NEWSFORMATTYPE . ":</b>&nbsp;"
     . "<select name=\"formattype\">"
     . "<option value=\"exttrans\"" . ((strpos($hometext, MX_NEWS_TYPE_EXTRANS)) ? ' selected="selected" class="current"' : '') . " >" . _EXTRANS . "</option>"
     . "<option value=\"html\" " . ((strpos($hometext, MX_NEWS_TYPE_HTML)) ? ' selected="selected" class="current"' : '') . " >" . _HTMLFORMATED . "</option>"
     . "<option value=\"plaintext\" " . ((strpos($hometext, MX_NEWS_TYPE_PLAINTEXT)) ? ' selected="selected" class="current"' : '') . " >" . _PLAINTEXT . "</option>"
     . "</SELECT>";
}

/**
 */
function vkpGetDate()
{
    $today = getdate();
    $thour = $today['hours'];
    if ($thour < 10) {
        $thour = "0$thour";
    }
    $tmin = $today['minutes'];
    if ($tmin < 10) {
        $tmin = "0$tmin";
    }
    $tsec = $today['seconds'];
    if ($tsec < 10) {
        $tsec = "0$tsec";
    }
    return mx_strftime(_DATESTRING, time()) . " $thour:$tmin:$tsec";
}

/**
 */
function vkpAutomatedSelect($year, $day, $month, $hour, $min)
{
    $title = _CHNGPROGRAMSTORY;
    $xday = 1;
    while ($xday <= 31) {
        $sel = ($xday == (int)$day) ? 'selected="selected" class="current"' : '';
        $d[] = "<option value=\"$xday\" $sel>$xday</option>";
        $xday++;
    }
    $xmonth = 1;
    while ($xmonth <= 12) {
        $sel = ($xmonth == (int)$month) ? 'selected="selected" class="current"' : '';
        $m[] = "<option value=\"$xmonth\" $sel>$xmonth</option>";
        $xmonth++;
    }
    $xhour = 0;
    while ($xhour <= 23) {
        $sel = ($xhour == (int)$hour) ? 'selected="selected" class="current"' : '';
        $yhour = ($xhour < 10) ? "0$xhour" : $xhour;
        $h[] = "<option value=\"$xhour\" $sel>$yhour</option>";
        $xhour++;
    }
    $xmin = 0;
    $min = floor($min / 5) * 5;
    while ($xmin <= 59) {
        $sel = ($xmin == (int)$min) ? 'selected="selected" class="current"' : '';
        $ymin = ($xmin < 10) ? "0$xmin" : $xmin;
        $mi[] = "<option value=\"$xmin\" $sel>$ymin</option>";
        $xmin = $xmin + 5;
    }
    echo "<br /><b>" . $title . "</b>&nbsp;&nbsp;";
    echo "<br /><span class=\"tiny\">" . _NOWIS . ": " . vkpGetDate() . "</span><br /><br />";
    echo " " . _DAY . ": <select name=\"day\">" . (implode("\n", $d)) . "</select>";
    echo " " . _UMONTH . ": <select name=\"month\">" . (implode("\n", $m)) . "</select>";
    echo " " . _YEAR . ": <input type=\"text\" name=\"year\" value=\"$year\" size=\"5\" maxlength=\"4\" />";
    echo " " . _HOUR . ": <select name=\"hour\">" . (implode("\n", $h)) . "</select>";
    echo " : <select name=\"min\">" . (implode("\n", $mi)) . "</select><br />";
}

/**
 */
function vkpNewsSelectTopicCat($story)
{
    echo"<table cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"><tr valign=\"top\">";
    echo"<td width=\"30%\"> ";
    vkpSelectTopic($story['topic']);
    echo "</td><td>&nbsp;&nbsp;</td><td width=\"70%\">";
    SelectCategory($story['catid']);
    echo "</td></tr></table><br />";
}

/**
 */
function vkpNewsSelectActComments($acomm = 0)
{
    // Achtung!!! acomm: 0 = Ja , 1 = Nein
    $sel1 = (empty($acomm)) ? 'checked="checked"' : '';
    $sel2 = (empty($acomm)) ? '' : 'checked="checked"';
    echo "<br /><b>" . _ACTIVATECOMMENTS . "</b>&nbsp;&nbsp;";
    echo "<input type=\"radio\" name=\"acomm\" value=\"0\" $sel1 />" . _YES . "&nbsp;";
    echo "<input type=\"radio\" name=\"acomm\" value=\"1\" $sel2 />" . _NO . '<br />';
}

/**
 */
function vkpTopicImage($topic, $full = 0, $align = "right")
{
    global $prefix, $tipath;
    if (empty($topic)) {
        $topicimage = "AllTopics.gif";
    } else {
        $result = sql_query("select topicimage from " . $prefix . "_topics where topicid='" . intval($topic) . "'");
        list($topicimage) = sql_fetch_row($result);
        if (empty($topicimage)) {
            $topicimage = "AllTopics.gif";
        }
    }
    $path = trim($tipath, ' ;,:./\\');
    if ($full) {
        return mxCreateImage($path . '/' . $topicimage, '', 0, 'align="' . $align . '"');
    } else {
        return $path . '/' . $topicimage;
    }
}

/**
 */
function vkpGetFirstTopic()
{
    global $prefix;
    $result = sql_query("select min(topicid) from " . $prefix . "_topics");
    list($tid) = sql_fetch_row($result);
    if (empty($tid)) $tid = 0;
    return $tid;
}

?>
